// Copyright (c) 2010 Moxie Marlinspike <moxie@thoughtcrime.org>

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 3 of the
// License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA


function ConnectionManager(proxyManager) {
  this.proxyManager = proxyManager;
  this.localProxies = new Array();
  this.initializeLocalProxies();
}

ConnectionManager.prototype.shutdown = function() {
  for (var i=0;i<this.localProxies.length;i++) {
    this.localProxies[i].shutdown();
  }
};

ConnectionManager.prototype.getProxyForURL = function(url) {
  for (var i=0;i<this.localProxies.length;i++) {
    if (this.localProxies[i].matchesURL(url)) {
      return this.localProxies[i];
    }
  }

  return null;
};

ConnectionManager.prototype.initializeLocalProxies = function() {
  for (var i=0;i<this.proxyManager.getProxyCount();i++) {
    var proxy = this.proxyManager.getProxyAtIndex(i);
    if (proxy.getEnabled()) {
      var localProxy = new LocalProxy(proxy);
      this.localProxies.push(localProxy);      
    }
  }
};